import java.util.Iterator;

public interface WordIndex extends Iterable<WordData> {
  // Insert a word
  void insert(String word, int line);
  // Get frequency of word
  int getFrequency(String word);
  // Number of different words
  int getDifferentWordCount();
  // Number of total words
  int getTotalWordCount();
  // Mean frequency of equal words
  double getMeanWordFrequency();
  // Get all words with equal or more frequency
  String[] getWordsWithMinFrequency(int frequency);
  // Get all words starting with the specified prefix
  String[] getWordsStartingWith(String prefix);
  // Get an iterator
  Iterator<WordData> iterator();
}

